--------------------------------------------------------------------------------------------
-- Oovee Ltd (c) 2011 - Code by Ricardo Rivera 
--------------------------------------------------------------------------------------------


function Initialise ()


 --file = io.open("../Railworks/Assets/Oovee/BRClass156Pack01/RailVehicles/Diesel/BRClass156/Default/CommonScripts/datos.csv","w")


RPM_MS156_ID = 15601
VRPM_MS156_ID = 15602
BRAKES_MS156_ID = 15603
STARTUP_MS156_ID = 15604
SURGE_MS156_ID = 15605
REVDOWN_MS156_ID = 15606
VFLUID_MS156_ID = 15607
WFLAT_MS156_ID = 15608

LIGHTS_MS156_ID = 15609






--------------------------------------------------------------------------------------------
-- VARIBLE LIST
--------------------------------------------------------------------------------------------

gTimeSalidaDatos = 0

gFlat = false
gFlatTime = 0
gStartTime = 1.2

gStandByTime = 600
gAutoOffTime = 600

gAWSReady = true
gAWSTesting = false

gReverserState = 0
gBrakeState = 0
gBrakeLock = false
gRegulator = 0
gRegulatorUpOld = 0
gRegulatorDownOld = 0
GearSensor = 0
gDra = 1
gWSP = false
gWSPLock = false
gWSPTime = 0
gWSPDelay = 0
gWSPDelayLock = false
gDraLock = false
gFluid = 100
gSpeed = 0
gSpeedAcel = 0
gAcel = 0
gAcelTime = 0
gAcelVel = 0
gCableFactor = 0
gTime = 0
gFluidTimeOld = 0
gArmed = true
gSensorUp = 0
gSensorDown = 0
gCSUp = 0
gCSUpLock = false
gWorking = 1
gDead = false

gSander = false
gSanderLock = false
gSanderTime = 0
gSanderReset = false

gScrollControl = 0
gScrollTime = 0

gStoppedTrain = true

gStartLightsTime = 0
gStarting = false


gInterLightDelay = false
gInterBrakeDelay = false
gInterLightTime = 0
gInterBrakeTime = 0
gInterTimeLock = false

gVrpm = 0
gVelUp = 0
gVelDown = 0

gRpmTime = 0
gRpmActual = 0
gRpmLock = false



LPeak = 0
LMin = 0
LMax = 0
TSurge = 0
TDrop = 0
Power = 0


gSubiendo = false
gBajando = false
gSub = 0
gBaj = 0

gSpeedoNeedleFactor = 0
RiseSpeedoFactor = 0
DropSpeedoFactor = 0
gSpeedometerTime = 0
gSpeedoDeformed = false
gSpring = false


gWiperState01 = 0
gWiperState02 = 0
gWiperTime01 = 0
gWiperTime02 = 0
gWiperLeftOld = 0
gWiperRightOld = 0
gWiperControl01 = 0
gWiperControl02 = 0
gWiperFactor01 = 0.05
gWiperFactor02 = 0.05
gWiperStoped = true

gWindowsTime = 0
gWindowLeftOld = 0
gWindowRightOld = 0

gSunBlindTime = 0
gSunBlindLeftOld = 0
gSunBlindRightOld = 0


gScroll = 0
gScrollTime = 0
gDest01 = 0
gDest02 = 0
gDest03 = 0
gDest04 = 0
gDest05 = 0
gDest06 = 0
gDest07 = 0
gDest08 = 0
gDest09 = 0
gDest10 = 0
gDest11 = 0

-- Steps of Rev ---------
gStep = 0

KEEPING = 0
SURGING = 1
DROPING = 2
RISING = 3
DECREASING = 4
FALLING = 5
COMPRESSOR_UP = 6
COMPRESSOR_DOWN = 7
FAST_FALLING = 8
SURGING_FAKE = 9


-------------------------




Call("BeginUpdate")



end



function OnControlValueChange ( name, index, value )

if Call( "*:ControlExists", name, index ) then
Call( "*:SetControlValue", name, index, value );
end











--******************Shutdown and Startup***********************


if name == "EngineStart" then

	if (Call( "*:GetControlValue", "EngineStart", 0) > 0.5 ) then 
		Call( "*:SetControlValue", "Startup", 0, 1 )
		
		if gWorking == (-1) then
		gStartLightsTime = Call("*:GetSimulationTime", 0) + 1
		Call( "*:SetControlValue", "WSP", 0, 1 )
		gStarting = true
		end
		
		gWorking = 1
	end
 end
 if name == "EngineStop" then
 
 Call( "*:SetControlValue", "Startup", 0, -1 )
 
	if (Call( "*:GetControlValue", "EngineStop", 0) > 0.5 ) then 
		Call( "*:SetControlValue", "Startup", 0, -1 )
		gWorking = -1
	end
end


--***********SANDER************

if name == "VirtualSander" then

	if Call("*:GetControlValue", "WSP", 0) == 1 then	
	
		if Call("*:GetControlValue", "VirtualThrottle", 0) > 0 or gBrakeState >= 0.3 then
		
			if Call( "*:GetControlValue", "VirtualSander", 0) > 0.5 and Call( "*:GetControlValue", "VirtualSander", 0) < 0.75 then 
			
				if gSpeed > 7 then
					gSander = true
				end
			end

			if Call( "*:GetControlValue", "VirtualSander", 0) == 0 then
				gSanderReset = false
			end
			
		end	
	
	end

end

	





--------------------------------------------------------------------------------------------
-- REGULATOR LINK
--------------------------------------------------------------------------------------------

	if name == "VirtualThrottle" then
	
	
	
	if math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0))  == 0 then
LPeak = 600
LMin = 600
LMax = 600
TSurge = 2
TDrop = 0
TRise = 5
Power = 0
elseif math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0))  == 1 then
LPeak = 950
LMin = 881
LMax = 860
TSurge = 2.1
TDrop = 3
TRise = 5
Power = 0.142857
elseif math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0))  == 2 then
LPeak = 1200
LMin = 950
LMax = 930
TSurge = 2.1
TDrop = 3
TRise = 5
Power = 0.28571
elseif math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0))  == 3 then
LPeak = 1371
LMin = 1085
LMax = 1199
TSurge = 2.1
TDrop = 3
TRise = 5
Power = 0.428571
elseif math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0))  == 4 then
LPeak = 1628
LMin = 1288
LMax = 1424
TSurge = 2.0
TDrop = 3
TRise = 5
Power = 0.571428
elseif math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0))  == 5 then
LPeak = 1885
LMin = 1690
LMax = 1700
TSurge = 1.8
TDrop = 3
TRise = 5
Power = 0.714285
elseif math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0))  == 6 then
LPeak = 2100
LMin = 1890
LMax = 1900
TSurge = 1.6
TDrop = 3
TRise = 5
Power = 0.857142
elseif math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0))  == 7 then
LPeak = 2300
LMin = 2090
LMax = 2100
TSurge = 1.4
TDrop = 3
TRise = 5
Power = 1


end
	
	
	
	if gReverserState ~= 0 then
		gRegulator = math.floor(Call( "*:GetControlValue", "VirtualThrottle", 0)) 
	end
end
	
-------------------------------------------------------------
---DRA--------------------
if name == "DRA" then

gDra = Call( "*:GetControlValue", "DRA", 0)
end
	
	
--------------------------------------------------------------------------------------------
-- REVERSER LINK
--------------------------------------------------------------------------------------------

if name == "VirtualReverser" then

		if (Call( "*:GetControlValue", "VirtualReverser", 0) == 0) then 
			gReverserState = 0
			Call("*:SetControlValue", "AWSClearCount", 0, 0)
			gAWSReady = true
			
			
		elseif (Call( "*:GetControlValue", "VirtualReverser", 0) == 1) then
			gReverserState = -1
		elseif (Call( "*:GetControlValue", "VirtualReverser", 0) == 2) then
			gReverserState = 0
		elseif (Call( "*:GetControlValue", "VirtualReverser", 0) == 3) then
			gReverserState = 1
		end
	Call( "*:SetControlValue", "Reverser", 0, gReverserState )
end

--------------------------------------------------------------------------------------------
-- TRAIN BRAKE LINK
--------------------------------------------------------------------------------------------

	if name == "VirtualTrainBrakeControl" then

		if (Call( "*:GetControlValue", "VirtualTrainBrakeControl", 0) == 0) then 
			gBrakeState = 0	
		elseif (Call( "*:GetControlValue", "VirtualTrainBrakeControl", 0) == 1) then
			gBrakeState = 0.203152	
		elseif (Call( "*:GetControlValue", "VirtualTrainBrakeControl", 0) == 2) then
			gBrakeState = 0.339188	
		elseif (Call( "*:GetControlValue", "VirtualTrainBrakeControl", 0) == 3) then
			gBrakeState = 0.58
		elseif (Call( "*:GetControlValue", "VirtualTrainBrakeControl", 0) == 4) then
			gBrakeState = 0.58
		gSander = true
		end
		
	if gBrakeLock == false	then
	Call( "*:SetControlValue", "TrainBrakeControl", 0, gBrakeState )
	end
	
	end

if name == "CompressorSpeedUp" then

gCSUp = Call( "*:GetControlValue", "CompressorSpeedUp", 0)

end



end

function Update (time)




gTime = Call("*:GetSimulationTime", 0)
gSpeed = Call("*:GetControlValue", "SpeedometerMPH", 0)
gScroll = Call("*:GetControlValue", "Destination", 0)

if (Call( "GetIsEngineWithKey") == 1) then
Call( "*:SetControlValue", "Startup", 0, gWorking )
end

-- Starting Flash Lights ----------

if gStarting == true then
if gTime > gStartLightsTime then
Call( "*:SetControlValue", "WSP", 0, 0 )
gStarting = false
end
end




--- Standby sensor---------------------------------
if (Call( "GetIsEngineWithKey") == 1) then

if Call("*:GetControlValue", "VirtualReverser", 0) ~= 0 or gWorking == (-1) then
gStandByTime = gTime + gAutoOffTime
end

if gTime > gStandByTime then
gWorking = (-1)
end
end


if Call("GetIsPlayer") == 1 then
if Call("*:GetControlValue", "VirtualRPM", 0) > 50 then
Call( "Exhaust 1:SetEmitterActive", 1)
else
Call( "Exhaust 1:SetEmitterActive", 0)
end
end





----------------Reverser Lock----------------


	
	if(Call( "*:GetControlValue", "VirtualThrottle", 0) ~= 0) or gSpeed > 0.05 then
	
	if (Call( "*:GetControlValue", "VirtualReverser", 0) < 1.5) and (Call( "*:GetControlValue", "VirtualReverser", 0) > 0.5) then
		Call( "*:SetControlValue", "VirtualReverser", 0, 1 )
	end
	if (Call( "*:GetControlValue", "VirtualReverser", 0) < 2.5) and (Call( "*:GetControlValue", "VirtualReverser", 0) > 1.5) then
		Call( "*:SetControlValue", "VirtualReverser", 0, 2 )
	end
	if (Call( "*:GetControlValue", "VirtualReverser", 0) < 3) and (Call( "*:GetControlValue", "VirtualReverser", 0) > 2.5) then
		Call( "*:SetControlValue", "VirtualReverser", 0, 3 )
	end
end

-- DRA lights----------------

if Call("*:GetControlValue", "DRA", 0) == 1 and  Call("*:GetControlValue", "VirtualReverser", 0) ~= 0 then
Call( "*:SetControlValue", "DRALight", 0, 1 )
--Call( "ActivateNode", "DRAButtonLit", 1)
		-- Call( "ActivateNode", "DRAGlow", 1)
		
		 else
		Call( "*:SetControlValue", "DRALight", 0, 0 )
		 end
		



	




--------------------------AWS SelfTest ------------------------
--------------------------------------------------------------

if  Call( "*:GetControlValue", "VirtualReverser", 0) ~= 0 and gAWSReady == true then

gAWSTesting = true

Call("*:SetControlValue", "AWSWarnCount", 0, 1)
Call("*:SetControlValue", "AWS", 0, 0)
gAWSReady = false

end


if Call( "*:GetControlValue", "AWSReset", 0) > 0.9 and gAWSReady == false and gAWSTesting == true then

Call("*:SetControlValue", "AWSWarnCount", 0, 0)
Call("*:SetControlValue", "AWSClearCount", 0, 1)
Call("*:SetControlValue", "AWS", 0, 1)
gAWSTesting = false
end




--------------------------------------------------------------

--***************************RPM DELAY***********************















--***************************SCROLLING*****************************************

if gTime > gScrollTime then
if gScroll >= 0 and gScroll <= 20 then
	if gDest01 ~= gScroll / 20 then
		Call("*:AddTime", "Dest01",  (gScroll / 20) - gDest01)
	end	
gDest01 = gScroll / 20
end
if gScroll >= 10 and gScroll <= 30 then
	if gDest02 ~= (gScroll - 10) / 20 then
		Call("*:AddTime", "Dest02",  ((gScroll - 10) / 20) - gDest02)
	end	
gDest02 = (gScroll - 10) / 20
end
if gScroll >= 20 and gScroll <= 40 then
	if gDest03 ~= (gScroll - 20) / 20 then
		Call("*:AddTime", "Dest03",  ((gScroll - 20) / 20) - gDest03)
	end	
gDest03 = (gScroll - 20) / 20
end
if gScroll >= 30 and gScroll <= 50 then
	if gDest04 ~= (gScroll - 30) / 20 then
		Call("*:AddTime", "Dest04",  ((gScroll - 30) / 20) - gDest04)
	end	
gDest04 = (gScroll - 30) / 20
end
if gScroll >= 40 and gScroll <= 60 then
	if gDest05 ~= (gScroll - 40) / 20 then
		Call("*:AddTime", "Dest05",  ((gScroll - 40) / 20) - gDest05)
	end	
gDest05 = (gScroll - 40) / 20
end
if gScroll >= 50 and gScroll <= 70 then
	if gDest06 ~= (gScroll - 50) / 20 then
		Call("*:AddTime", "Dest06",  ((gScroll - 50) / 20) - gDest06)
	end	
gDest06 = (gScroll - 50) / 20
end
if gScroll >= 60 and gScroll <= 80 then
	if gDest07 ~= (gScroll - 60) / 20 then
		Call("*:AddTime", "Dest07",  ((gScroll - 60) / 20) - gDest07)
	end	
gDest07 = (gScroll - 60) / 20
end
if gScroll >= 70 and gScroll <= 90 then
	if gDest08 ~= (gScroll - 70) / 20 then
		Call("*:AddTime", "Dest08",  ((gScroll - 70) / 20) - gDest08)
	end	
gDest08 = (gScroll - 70) / 20
end
if gScroll >= 80 and gScroll <= 100 then
	if gDest09 ~= (gScroll - 80) / 20 then
		Call("*:AddTime", "Dest09",  ((gScroll - 80) / 20) - gDest09)
	end	
gDest09 = (gScroll - 80) / 20
end
if gScroll >= 90 and gScroll <= 110 then
	if gDest10 ~= (gScroll - 90) / 20 then
		Call("*:AddTime", "Dest10",  ((gScroll - 90) / 20) - gDest10)
	end	
gDest10 = (gScroll - 90) / 20
end
if gScroll >= 100 and gScroll <= 120 then
	if gDest11 ~= (gScroll - 100) / 20 then
		Call("*:AddTime", "Dest11",  ((gScroll - 100) / 20) - gDest11)
	end	
gDest11 = (gScroll - 100) / 20
end
gScrollTime = gTime + 0.0125
end


--*****************************************************************************


--****************DESTINATION LIGHT************************
if math.floor(Call("*:GetControlValue", "DestinationLight", 0)) == 1 then
Call( "ActivateNode", "DestinationLight", 1)
Call( "ActivateNode", "Destination", 0)
elseif math.floor(Call("*:GetControlValue", "DestinationLight", 0)) == 0 then
Call( "ActivateNode", "DestinationLight", 0)
Call( "ActivateNode", "Destination", 1)
end





--***************DOORS INTERLOCK******************************-******


if Call("*:GetControlValue", "DoorsOpenCloseRight", 0) == 1 or Call("*:GetControlValue", "DoorsOpenCloseLeft", 0) == 1 then
Call( "ActivateNode", "Interlock", 1)
Call( "*:SetControlValue", "GuardSignal", 0, 0 )
msg = REVDOWN_MS156_ID
	argument = 1
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )


Call( "*:SetControlValue", "TrainBrakeControl", 0, 0.58 )
gInterTimeLock = true
gBrakeLock = true
end

if Call("*:GetControlValue", "DoorsOpenCloseRight", 0) == 0 and Call("*:GetControlValue", "DoorsOpenCloseLeft", 0) == 0 and gBrakeLock == true and gInterTimeLock == true then

msg = REVDOWN_MS156_ID
	argument = 0
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )

gInterBrakeDelay = true
gInterBrakeTime = gTime + 7
gInterTimeLock = false
end

if gInterBrakeDelay == true then
	if gTime > gInterBrakeTime then
	Call( "*:SetControlValue", "TrainBrakeControl", 0, gBrakeState )
	gBrakeLock = false
	Call( "ActivateNode", "Interlock", 0)
	Call( "*:SetControlValue", "GuardSignal", 0, 1)
	gInterBrakeDelay = false
	end
end

if Call("*:GetControlValue", "DoorsOpenCloseRight", 0) == 0 and Call("*:GetControlValue", "DoorsOpenCloseLeft", 0) == 0 and gInterBrakeDelay == false then
Call( "ActivateNode", "Interlock", 0)
Call( "*:SetControlValue", "GuardSignal", 0, 1 )
msg = REVDOWN_MS156_ID
	argument = 0
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
end

----------------------------------------------------------

if Call("*:GetControlValue", "DoorsOpenCloseRight", 0) == 0 and Call("*:GetControlValue", "DoorsOpenCloseLeft", 0) == 0 then


if Call("*:GetControlValue", "Interlock", 0) == 1 then
Call( "ActivateNode", "Interlock", 1)
Call( "*:SetControlValue", "GuardSignal", 0, 0 )
Call( "*:SetControlValue", "TrainBrakeControl", 0, 0.58 )
gInterTimeLock = true
gBrakeLock = true
end

if Call("*:GetControlValue", "Interlock", 0) == 0 and gBrakeLock == true and gInterTimeLock == true then



gInterBrakeDelay = true
gInterBrakeTime = gTime + 7
gInterTimeLock = false
end

if gInterBrakeDelay == true then
	if gTime > gInterBrakeTime then
	Call( "*:SetControlValue", "TrainBrakeControl", 0, gBrakeState )
	gBrakeLock = false
	Call( "ActivateNode", "Interlock", 0)
Call( "*:SetControlValue", "GuardSignal", 0, 1 )
	gInterBrakeDelay = false
	end
end

if Call("*:GetControlValue", "Interlock", 0) == 0 and gInterBrakeDelay == false then
Call( "ActivateNode", "Interlock", 0)
Call( "*:SetControlValue", "GuardSignal", 0, 1 )
end
end





--*******************************LIGHTS CONTROL************************
--marker-----

if Call("GetIsPlayer") == 1 then

if math.floor(Call("*:GetControlValue", "MarkerLight", 0)) == 0 then
Call( "ActivateNode", "MarkerLights", 0)
elseif math.floor(Call("*:GetControlValue", "MarkerLight", 0)) == 1 then
Call( "ActivateNode", "MarkerLights", 1)
end



--tail----
if math.floor(Call("*:GetControlValue", "TailLight", 0)) == 0 then
Call( "ActivateNode", "TailLights", 0)
elseif math.floor(Call("*:GetControlValue", "TailLight", 0)) == 1 then
Call( "ActivateNode", "TailLights", 1)
end

--head----
if math.floor(Call("*:GetControlValue", "Headlight", 0)) == 0 then
Call( "ActivateNode", "HeadlightLeft", 0)
Call( "ActivateNode", "HeadlightLRight", 0)
elseif math.floor(Call("*:GetControlValue", "Headlight", 0)) == 1 then
Call( "ActivateNode", "HeadlightLeft", 1)
Call( "ActivateNode", "HeadlightLRight", 0)
elseif math.floor(Call("*:GetControlValue", "Headlight", 0)) == 2 then
Call( "ActivateNode", "HeadlightLeft", 0)
Call( "ActivateNode", "HeadlightLRight", 1)
end
end

if Call("GetIsPlayer") == 0 then

	if Call("GetSpeed") > 0.1 then
		Call( "ActivateNode", "TailLights", 0)
		Call( "ActivateNode", "MarkerLights", 1)
		Call( "ActivateNode", "HeadlightLeft", 0)
		Call( "ActivateNode", "HeadlightLRight", 1)
		gStoppedTrain = false
	elseif Call("GetSpeed") < (-0.1) then
		Call( "ActivateNode", "TailLights", 1)
		Call( "ActivateNode", "MarkerLights", 0)
		Call( "ActivateNode", "HeadlightLeft", 0)
		Call( "ActivateNode", "HeadlightLRight", 0)
		gStoppedTrain = false
	end

	if Call("GetSpeed") < 0.1 and Call("GetSpeed") > (-0.1) and gStoppedTrain == true then
		Call( "ActivateNode", "TailLights", 1)
		Call( "ActivateNode", "MarkerLights", 0)
		Call( "ActivateNode", "HeadlightLeft", 0)
		Call( "ActivateNode", "HeadlightLRight", 0)
	end
end


--*********************************************************************

--***********************WIPERS 2 SPEEDS CONTROL************************

gWiperState01 = math.floor(Call("*:GetControlValue", "WiperDriver", 0))
gWiperState02 = math.floor(Call("*:GetControlValue", "WiperSecond", 0))


if gWiperState01 == 1 then
	gWiperStoped01 = false
	gWiperFactor01 = 0.015
elseif gWiperState01 == 2 then
	gWiperStoped01 = false
	gWiperFactor01 = 0.0375
end


if gWiperState02 == 1 then
	gWiperStoped02 = false
	gWiperFactor02 = 0.015
elseif gWiperState02 == 2 then
	gWiperStoped02 = false
	gWiperFactor02 = 0.0375
end






if gWiperStoped01 == false then
	if gTime > gWiperTime01 then
		if gWiperControl01 >= 0 and gWiperControl01 < 1 then
			Call("*:SetControlValue", "WiperLeft", 0, gWiperControl01)
			gWiperControl01 = gWiperControl01 + gWiperFactor01
		end

		if gWiperControl01 >= 1 and gWiperControl01 < 2.1 then
			Call("*:SetControlValue", "WiperLeft", 0, 2 - gWiperControl01)
			gWiperControl01 = gWiperControl01 + gWiperFactor01
		end 


		if gWiperControl01 > 2 then
			gWiperControl01 = 0
			gWiperStoped01 = true
		end 
		
		if gWiperLeftOld ~= Call("*:GetControlValue", "WiperLeft", 0) then
			Call("*:AddTime", "WiperL", Call("*:GetControlValue", "WiperLeft", 0) - gWiperLeftOld )
		end
		gWiperLeftOld = Call("*:GetControlValue", "WiperLeft", 0)
		gWiperTime01 = gTime + 0.0125
	end
end


--------------------------------------


if gWiperStoped02 == false then
	if gTime > gWiperTime02 then
		if gWiperControl02 >= 0 and gWiperControl02 < 1 then
			Call("*:SetControlValue", "WiperRight", 0, gWiperControl02)
			gWiperControl02 = gWiperControl02 + gWiperFactor02
		end

		if gWiperControl02 >= 1 and gWiperControl02 < 2.01 then
			Call("*:SetControlValue", "WiperRight", 0, 2 - gWiperControl02)
			gWiperControl02 = gWiperControl02 + gWiperFactor02
		end 


		if gWiperControl02 > 2 then
			
			gWiperControl02 = 0
			gWiperStoped02 = true
		end 
		
		if gWiperRightOld ~= Call("*:GetControlValue", "WiperRight", 0) then
			Call("*:AddTime", "WiperR", Call("*:GetControlValue", "WiperRight", 0) - gWiperRightOld )
		end
		gWiperRightOld = Call("*:GetControlValue", "WiperRight", 0)
		gWiperTime02 = gTime + 0.0125
	end
end




--*****************************************************************************

--*************************CONTROL OF EXTERNAL WINDOWS**************************

if gTime > gWindowsTime then
	if gWindowLeftOld ~= Call("*:GetControlValue", "WindowLeft", 0) then
		Call("*:AddTime", "WindowLeft", Call("*:GetControlValue", "WindowLeft", 0) - gWindowLeftOld )
	end
	if gWindowRightOld ~= Call("*:GetControlValue", "WindowRight", 0) then
		Call("*:AddTime", "WindowRight", Call("*:GetControlValue", "WindowRight", 0) - gWindowRightOld )
	end
	gWindowLeftOld = Call("*:GetControlValue", "WindowLeft", 0)
	gWindowRightOld = Call("*:GetControlValue", "WindowRight", 0)
	gWindowsTime = gTime + 0.0125
end


--******************************************************************************


--**************************CONTROL OF SUNBLINDS*********************************



if gTime > gSunBlindTime then
	if gSunBlindLeftOld ~= Call("*:GetControlValue", "SunblindLeft", 0) then
		Call("*:AddTime", "SunBlindLeft", Call("*:GetControlValue", "SunblindLeft", 0) - gSunBlindLeftOld )
	end
	if SunBlindRightOld ~= Call("*:GetControlValue", "SunblindRight", 0) then
		Call("*:AddTime", "SunBlindRight", Call("*:GetControlValue", "SunblindRight", 0) - gSunBlindRightOld )
	end
	gSunBlindLeftOld = Call("*:GetControlValue", "SunblindLeft", 0)
	gSunBlindRightOld = Call("*:GetControlValue", "SunblindRight", 0)
	gSunBlindTime = gTime + 0.0125
end






--*******************************************************************************




--************SPEEDO NEEDLE DEFORMATION*****************

if Call("*:GetControlValue", "Wheelslip", 0) == 1 then
gSpeedoNeedleFactor = Call("*:GetControlValue", "SpeedometerMPH", 0)
gSpring = false
	if gSpeedDeformed == false then
		RiseSpeedoFactor = gSpeedoNeedleFactor - Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0)
		DropSpeedoFactor = 	Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0) - gSpeedoNeedleFactor
	else
	RiseSpeedoFactor = (gSpeedoNeedleFactor - Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0)) / 10
	DropSpeedoFactor = (Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0) - gSpeedoNeedleFactor) / 10
	end
end

if Call("*:GetControlValue", "Wheelslip", 0) == 2 then

	if gSpring == false then
		gSpeedoNeedleFactor = Call("*:GetControlValue", "SpeedometerMPH", 0) + 30
		gSpeedDeformed = true
		RiseSpeedoFactor = (gSpeedoNeedleFactor - Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0)) / 30
	
		
	
	end
	
	if Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0) > Call("*:GetControlValue", "SpeedometerMPH", 0) + 20 then
		gSpring = true
		gSpeedoNeedleFactor = Call("*:GetControlValue", "SpeedometerMPH", 0)
		DropSpeedoFactor = (Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0) - gSpeedoNeedleFactor) / 50
		end




end



if Call("*:GetControlValue", "Wheelslip", 0) == 0 then
gSpeedoNeedleFactor = 0
gSpeedDeformed = true
DropSpeedoFactor = (Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0) - gSpeedoNeedleFactor) / 10
end

if Call("*:GetControlValue", "VirtualSpeedometerMPH", 0) > (Call("*:GetControlValue", "SpeedometerMPH", 0) - 0.5) and  Call("*:GetControlValue", "VirtualSpeedometerMPH", 0) < (Call("*:GetControlValue", "SpeedometerMPH", 0) + 0.5)then
gSpeedDeformed = false

end

if gTime > gSpeedometerTime then

if gSpeedoNeedleFactor > Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0) then
		Call("*:SetControlValue", "VirtualSpeedometerMPH", 0, Call("*:GetControlValue", "VirtualSpeedometerMPH", 0) + RiseSpeedoFactor)
end
if gSpeedoNeedleFactor < Call( "*:GetControlValue", "VirtualSpeedometerMPH", 0) then
		Call("*:SetControlValue", "VirtualSpeedometerMPH", 0, Call("*:GetControlValue", "VirtualSpeedometerMPH", 0) - DropSpeedoFactor)
end
gSpeedometerTime = gTime + 0.025
end


--***************************************************************************************************




-- Calculating the Aceleration -----------
------------------------------------------

gSpeedAcel = Call("GetSpeed")


if Call("*:GetSimulationTime", 0) > gAcelTime then
gAcel = (gSpeedAcel - gAcelVel) / 0.1

gAcelVel = gSpeedAcel
gAcelTime = Call("*:GetSimulationTime", 0) + 0.1
end


if gAcel > 0 then 
gCableFactor = 1
end

if gAcel < 0 then
gCableFactor = -1
end


if gAcel > (-0.05) and gAcel < 0.05 then
gCableFactor = 0
end



--***********************smoothing the cable motion************

if gCableFactor > Call( "*:GetControlValue", "Cable", 0) then
	
	local RiseCableFactor = 0.01 --(gAcel - Call("*:GetControlValue", "Cable", 0)) --/ 150) + 2
		Call("*:SetControlValue", "Cable", 0, Call("*:GetControlValue", "Cable", 0) + RiseCableFactor)
end
if gCableFactor < Call( "*:GetControlValue", "Cable", 0) then
		
	local DropCableFactor = 0.01 --(Call("*:GetControlValue", "Cable", 0) - gAcel) --/ 150) + 2
		Call("*:SetControlValue", "Cable", 0, Call("*:GetControlValue", "Cable", 0) - DropCableFactor)
end




--*************************SANDER RUTINES***************




	if gSander == true then
		gSanderLock = true
		gSanderTime = gTime + 10
		gSander = false
		gSanderReset = true
	end
	if gSanderLock == true then
		Call( "*:SetControlValue", "Sander", 0, 1)
		if gTime > gSanderTime then
			Call( "*:SetControlValue", "Sander", 0, 0)
			gSanderLock = false
		end
	end
	
	





--****************************WSP RUTINE ***************
if (Call( "GetIsEngineWithKey") == 1) then

	if Call("*:GetControlValue", "Wheelslip", 0) > 1.95 or Call("*:GetControlValue", "Wheelslip", 0) < 0.5 then
		
		gWSP = true
		
		if gWSPDelayLock == false then
		gWSPDelay = gTime + 0.5
		gWSPDelayLock = true
		end
		
		
		if Call("*:GetControlValue", "TrainBrakeCylinderPressureBAR", 0) > 1.1 then
			gFlat = true
			
		end	
	end

	if gFlat == true then

		if Call( "*:GetControlValue", "WheelFlat", 0) == 1 then
		gFlat = false
		end


		if gTime > gFlatTime then
		Call("*:SetControlValue", "WheelFlat", 0, Call( "*:GetControlValue", "WheelFlat", 0) + 0.1)
		gFlatTime = gTime + 0.1
		end
	end



	if gWSP == true and gTime > gWSPDelay then
		gStep = FAST_FALLING
		Call("*:SetControlValue", "WSP", 0, 1)
		if Call( "*:GetControlValue", "VirtualRPM", 0) == 600 then
		gWSPLock = true
		gWSPTime = gTime + 2
		gWSP = false
		gWSPDelayLock = false
		end
	end

	if gWSPLock == true then
		if gTime > gWSPTime then
			Call("*:SetControlValue", "WSP", 0, 0)
			gStep = SURGING_FAKE
			gWSPLock = false
		end
	end

--********************************************************	



	if gWorking == -1 then
			gVelDown = 15
			gSubiendo = false
			gBajando = true
			if Call("*:GetControlValue", "VirtualRPM", 0) == 0 then
			gDead = true
			end
			end
		

	if gWorking == 1 then
		if gDead == true then
		gVelUp = 600 / (gStartTime * 40)
			gSubiendo = true
			gBajando = false
			
			if Call("*:GetControlValue", "VirtualRPM", 0) > 550 then
			
			gDead = false
			gSubiendo = false
			gBajando = false
			
			end
		end	
	end
		

--end
		

if gWorking == 1 then		

if gCSUp == 1 and Call("*:GetControlValue", "VirtualThrottle", 0) == 0  and Call( "*:GetControlValue", "VirtualReverser", 0) == 2 then
	if gSpeed < 0.01 then
		gVelUp = 30
		gSubiendo = true
		gBajando = false
		--if Call("*:GetControlValue", "VirtualRPM", 0) > 2395 then
		gCSUpLock = true
		Call("*:SetControlValue", "Surge", 0, 1)
		--end
	end	
end
if gCSUp == 0 and gCSUpLock == true then
	gVelDown = 30
		gSubiendo = false
		gBajando = true
		--Call("*:SetControlValue", "RevDown", 0, 1)
		if Call("*:GetControlValue", "VirtualRPM", 0) == 600 then
		
		gCSUpLock = false
		
		end
end

end



--****************moviendo el regulador real*************** *******

--****************************************************************
if gDra == 0 and gDraLock == false then

	if gRegulator ~= gRegulatorUpOld then
		if gRegulator > gRegulatorUpOld then
			gStep = SURGING
		end
		
		if  gRegulator < gRegulatorUpOld then
			gStep = DECREASING
		end
		gRegulatorUpOld = gRegulator
	end





					
else
gStep = FALLING
	if Call( "*:GetControlValue", "VirtualThrottle", 0) > 0 then
	gDraLock = true
	end
end






 if gDra == 0 and gDraLock == true then
 Call("*:SetControlValue", "VirtualRPM", 0, 600)
 Call("*:SetControlValue", "Regulator", 0, 0)
 if Call( "*:GetControlValue", "VirtualThrottle", 0) == 0 then
 gDraLock = false
 end
end



-- subiendo el valor

if gSubiendo == true then
	if gTime > gFluidTimeOld then
		gTempFluid = Call("*:GetControlValue", "VirtualRPM", 0)
		gVrpm = Call("*:GetControlValue", "VirtualRPM", 0)
		Call("*:SetControlValue", "VirtualRPM", 0, gTempFluid + gVelUp)
	gFluidTimeOld = gTime + 0.025
	end
end


--bajando el valor

if gBajando == true then
	if gTime > gFluidTimeOld then
		gTempFluid = Call("*:GetControlValue", "VirtualRPM", 0)
		gVrpm = Call("*:GetControlValue", "VirtualRPM", 0)
		Call("*:SetControlValue", "VirtualRPM", 0, gTempFluid - gVelDown)
	gFluidTimeOld = gTime + 0.025
	end
end



if gStep == SURGING_FAKE then
gVelUp = (LPeak - 600) / (TSurge * 40)
Subiendo = true
gBajando = false
end





if gStep == SURGING then
gVelUp = (LPeak - 600) / (TSurge * 40)
if gArmed == true then
Call("*:SetControlValue", "Surge", 0, 1)
end
gSubiendo = true
gBajando = false
else
if gCSUp == 0 then
Call("*:SetControlValue", "Surge", 0, 0)
end
end



if gArmed == true then
if gStep == SURGING and gVrpm >= LPeak then
gStep = DROPING
gVelDown = (LPeak - LMin) / (TDrop * 40)
gSubiendo = false
gBajando = true
Call("*:SetControlValue", "Regulator", 0, Power)
gArmed = false
end
end

if gArmed == false then
if gStep == SURGING and gVrpm >= LMin then
gStep = DROPING
gVelDown = (LMin - 600) / (TDrop * 40)
gSubiendo = false
gBajando = true
Call("*:SetControlValue", "Regulator", 0, Power)
end
end



if gStep == DROPING and gVrpm <= LMin then
gStep = RISING
gVelUp = (LMax - LMin) / (TRise * 40)
gSubiendo = true
gBajando = false

--********
--Call("*:SetControlValue", "Regulator", 0, Power)
--********

end

if gStep == RISING and gVrpm >= LMax then
gStep = KEEPING
gSubiendo = false
gBajando = false
end

if gStep == DECREASING then
gVelDown = 15 --10 / TSurge
gSubiendo = false
gBajando = true
Call("*:SetControlValue", "Regulator", 0, Power)
--Call("*:SetControlValue", "RevDown", 0, 1)
else
	if gStep ~= FALLING and gCSUpLock == false then
		--Call("*:SetControlValue", "RevDown", 0, 0)
	end
end

if gStep == DECREASING and gVrpm <= LMin then
gStep = KEEPING
gSubiendo = false
gBajando = false
end

if gStep == FALLING then
gVelDown = 15 --/ TSurge
gSubiendo = false
gBajando = true
Call("*:SetControlValue", "Regulator", 0, 0)
--Call("*:SetControlValue", "RevDown", 0, 1)
end

if gStep == FAST_FALLING then
gVelDown = 22.5 / TSurge
gSubiendo = false
gBajando = true
Call("*:SetControlValue", "Regulator", 0, 0)
end

if gStep == FALLING and gVrpm <= 600 then
gStep = KEEPING
gSubiendo = false
gBajando = false
end

if gStep == FAST_FALLING and gVrpm <= 600 then
gStep = KEEPING
gSubiendo = false
gBajando = false
end

end


if (Call( "GetIsEngineWithKey") == 1) and Call( "GetIsPlayer" ) == 1 then

if gWorking > 0 and gDead == false and gSpeed < 47 then
	if Call( "*:GetControlValue", "VirtualRPM", 0) < 600 then
		gArmed = true
		Call( "*:SetControlValue", "VirtualRPM", 0, 600)
	end
end

end



if (Call( "GetIsPlayer" )  == 0) then
 Call("*:SetControlValue", "VirtualRPM", 0, Call( "*:GetControlValue", "RPM", 0)) 
end


--*********************************************************************************************
--*********************************************************************************************

if (Call( "GetIsEngineWithKey") == 1) then
if gSpeed < 50 then
GearSensor = (gSpeed - 47) * 1.2
Call("*:SetControlValue", "VirtualFluid", 0, GearSensor)
elseif gSpeed >= 50 then
GearSensor = 1 - ((gSpeed - 50) * 0.008)
Call("*:SetControlValue", "VirtualFluid", 0, GearSensor)
end
end




--********************SENDING MESSAGES****************************

if (Call( "GetIsEngineWithKey") == 1) then	
	msg = RPM_MS156_ID
	argument = Call( "*:GetControlValue", "RPM", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
end


if (Call( "GetIsEngineWithKey") == 1) then	
	msg = VRPM_MS156_ID
	argument = Call( "*:GetControlValue", "VirtualRPM", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
end

if (Call( "GetIsEngineWithKey") == 1) then	
	msg = LIGHTS_MS156_ID
	argument = Call( "*:GetControlValue", "Horn", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
	end






if (Call( "GetIsEngineWithKey") == 1) then	
	msg = BRAKES_MS156_ID
	argument =  Call( "*:GetControlValue", "TrainBrakeCylinderPressureBAR", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
	end

if (Call( "GetIsEngineWithKey") == 1) then	
	msg = STARTUP_MS156_ID
	argument = Call( "*:GetControlValue", "Startup", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
end

if (Call( "GetIsEngineWithKey") == 1) then	
	msg = SURGE_MS156_ID
	argument = Call( "*:GetControlValue", "Surge", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
end

if (Call( "GetIsEngineWithKey") == 1) then	
	msg = REVDOWN_MS156_ID
	argument = Call( "*:GetControlValue", "Interlock", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
end

if (Call( "GetIsEngineWithKey") == 1) then	
	msg = VFLUID_MS156_ID
	argument = Call( "*:GetControlValue", "VirtualFluid", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
end


if (Call( "GetIsEngineWithKey") == 1) then	
	msg = WFLAT_MS156_ID
	argument = Call( "*:GetControlValue", "WheelFlat", 0 )
	Call( "SendConsistMessage", msg, argument, 0 )
	Call( "SendConsistMessage", msg, argument, 1 )
end

Call("*:SetControlValue", "Headlights", 0, 1)

end
--------------------------------------------------------------------------------------------
-- TRAIN DATA SYCRONISATION
--------------------------------------------------------------------------------------------

function OnConsistMessage ( msg, argument, direction )

if (Call( "GetIsEngineWithKey") == 0) then
if msg == RPM_MS156_ID then
	Call( "*:SetControlValue", "RPM", 0, argument  )
	Call( "SendConsistMessage", msg, argument, direction )
end
end


if (Call( "GetIsEngineWithKey") == 0) then
if msg == VRPM_MS156_ID then
	Call( "*:SetControlValue", "VirtualRPM", 0, argument + 20)
	Call( "SendConsistMessage", msg, argument, direction )
end
end



if (Call( "GetIsEngineWithKey") == 0) then
	if msg == BRAKES_MS156_ID then
		Call( "SendConsistMessage", msg, argument, direction )
	end
end




if (Call( "GetIsEngineWithKey") == 0) then
if msg == STARTUP_MS156_ID then
	Call( "*:SetControlValue", "Startup", 0, argument )
	Call( "SendConsistMessage", msg, argument, direction )
end
end


if (Call( "GetIsEngineWithKey") == 0) then
if msg == SURGE_MS156_ID then
	Call( "*:SetControlValue", "Surge", 0, argument )
	Call( "SendConsistMessage", msg, argument, direction )
end
end

--if (Call( "GetIsEngineWithKey") == 0) then
if msg == REVDOWN_MS156_ID then
	Call( "*:SetControlValue", "Interlock", 0, argument )
	Call( "SendConsistMessage", msg, argument, direction )
end
--end

if (Call( "GetIsEngineWithKey") == 0) then
if msg == VFLUID_MS156_ID then
	Call( "*:SetControlValue", "VirtualFluid", 0, argument )
	Call( "SendConsistMessage", msg, argument, direction )
end
end

if (Call( "GetIsEngineWithKey") == 0) then
if msg == WFLAT_MS156_ID then
	Call( "*:SetControlValue", "WheelFlat", 0, argument )
	Call( "SendConsistMessage", msg, argument, direction )
end
end


end


function SalidaDatos()
--file:write(gSpeedoNeedleFactor.."\n")
end



























